package jp.hishidama.win32.mshtml;

import jp.hishidama.win32.com.ComPtr;
import jp.hishidama.win32.com.IDispatch;
import jp.hishidama.win32.com.Variant;
import jp.hishidama.win32.shdocvw.IWebBrowser;

/**
 * IHTMLDocument2`4NX.
 * <p>
 * HTMLhLgNXłB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.10.22
 * @version 2008.07.14
 */
public class IHTMLDocument extends IDispatch {

	protected IHTMLDocument(long ptr) {
		super(ptr);
	}

	public IDispatch getScript() {
		return Native.get_Script(getPtr());
	}

	/**
	 * SHTMLvf擾.
	 * 
	 * @return RNV
	 */
	public IHTMLElementCollection getAll() {
		return Native.get_all(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getAll()
	 */
	public IHTMLElementCollection getAll(boolean addChild) {
		return getAll();
	}

	/**
	 * {fB[vf擾.
	 * 
	 * @return HTMLvf
	 */
	public IHTMLElement getBody() {
		return Native.get_body(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getBody()
	 */
	public IHTMLElement getBody(boolean addChild) {
		return getBody();
	}

	/**
	 * ANeBuvf擾.
	 * 
	 * @return HTMLvf
	 */
	public IHTMLElement getActiveElement() {
		return Native.get_activeElement(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getActiveElement()
	 */
	public IHTMLElement getActiveElement(boolean addChild) {
		return getActiveElement();
	}

	/**
	 * 摜vf擾.
	 * 
	 * @return RNV
	 */
	public IHTMLElementCollection getImages() {
		return Native.get_images(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getImages()
	 */
	public IHTMLElementCollection getImages(boolean addChild) {
		return getImages();
	}

	/**
	 * Nvf擾.
	 * 
	 * @return RNV
	 */
	public IHTMLElementCollection getLinks() {
		return Native.get_links(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getLinks()
	 */
	public IHTMLElementCollection getLinks(boolean addChild) {
		return getLinks();
	}

	/**
	 * tH[擾.
	 * 
	 * @return RNV
	 */
	public IHTMLElementCollection getForms() {
		return Native.get_forms(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getForms()
	 */
	public IHTMLElementCollection getForms(boolean addChild) {
		return getForms();
	}

	/**
	 * AJ[vf擾.
	 * 
	 * @return RNV
	 */
	public IHTMLElementCollection getAnchors() {
		return Native.get_anchors(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getAnchors()
	 */
	public IHTMLElementCollection getAnchors(boolean addChild) {
		return getAnchors();
	}

	/**
	 * ^Cgݒ.
	 * 
	 * @param title
	 *            ^Cg
	 */
	public void setTitle(String title) {
		Native.put_title(getPtr(), title);
	}

	/**
	 * ^Cg擾.
	 * 
	 * @return ^Cg
	 */
	public String getTitle() {
		return Native.get_title(getPtr());
	}

	/**
	 * ReadyState擾.
	 * 
	 * @return ReadyState
	 */
	public String getReadyState() {
		return Native.get_readyState(getPtr());
	}

	/**
	 * t[擾.
	 * 
	 * @return RNV
	 */
	public IHTMLFramesCollection getFrames() {
		return Native.get_frames(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getFrames()
	 */
	public IHTMLFramesCollection getFrames(boolean addChild) {
		return getFrames();
	}

	public void setAlinkColor(Variant color) {
		Native.put_alinkColor(getPtr(), color);
	}

	public Variant getAlinkColor() {
		return Native.get_alinkColor(getPtr());
	}

	public void setBgColor(Variant color) {
		Native.put_bgColor(getPtr(), color);
	}

	public Variant getBgColor() {
		return Native.get_bgColor(getPtr());
	}

	public void setFgColor(Variant color) {
		Native.put_fgColor(getPtr(), color);
	}

	public Variant getFgColor() {
		return Native.get_fgColor(getPtr());
	}

	public void setLinkColor(Variant color) {
		Native.put_linkColor(getPtr(), color);
	}

	public Variant getLinkColor() {
		return Native.get_linkColor(getPtr());
	}

	public void setVlinkColor(Variant color) {
		Native.put_vlinkColor(getPtr(), color);
	}

	public Variant getVlinkColor() {
		return Native.get_vlinkColor(getPtr());
	}

	public String getReferrer() {
		return Native.get_referrer(getPtr());
	}

	public IHTMLLocation getLocation() {
		return Native.get_location(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getLocation()
	 */
	public IHTMLLocation getLocation(boolean addChild) {
		return getLocation();
	}

	/**
	 * ŏIXV擾.
	 * 
	 * @return t
	 */
	public String getLastModified() {
		return Native.get_lastModified(getPtr());
	}

	/**
	 * URLݒ.
	 * 
	 * @param url
	 *            URL
	 */
	public void setUrl(String url) {
		Native.put_url(getPtr(), url);
	}

	/**
	 * URL擾.
	 * 
	 * @return URL
	 */
	public String getUrl() {
		return Native.get_url(getPtr());
	}

	/**
	 * hCݒ.
	 * 
	 * @param domain
	 *            hC
	 */
	public void setDomain(String domain) {
		Native.put_domain(getPtr(), domain);
	}

	/**
	 * hC擾.
	 * 
	 * @return hC
	 */
	public String getDomain() {
		return Native.get_domain(getPtr());
	}

	/**
	 * NbL[ݒ.
	 * 
	 * @param cookie
	 *            NbL[
	 */
	public void setCookie(String cookie) {
		Native.put_cookie(getPtr(), cookie);
	}

	/**
	 * NbL[擾.
	 * 
	 * @return NbL[
	 */
	public String getCookie() {
		return Native.get_cookie(getPtr());
	}

	/**
	 * Zbgݒ.
	 * 
	 * @param charset
	 *            LZbg
	 */
	public void setCharset(String charset) {
		Native.put_charset(getPtr(), charset);
	}

	/**
	 * Zbg擾.
	 * 
	 * @return LZbg
	 */
	public String getCharset() {
		return Native.get_charset(getPtr());
	}

	/**
	 * ftHgZbgݒ.
	 * 
	 * @param charset
	 *            LZbg
	 */
	public void setDefaultCharset(String charset) {
		Native.put_defaultCharset(getPtr(), charset);
	}

	/**
	 * ftHgZbgݒ.
	 * 
	 * @return LZbg
	 */
	public String getDefaultCharset() {
		return Native.get_defaultCharset(getPtr());
	}

	/**
	 * MIME^Cv擾.
	 * 
	 * @return MIME^Cv
	 */
	public String getMimeType() {
		return Native.get_mimeType(getPtr());
	}

	/**
	 * t@CTCY擾.
	 * 
	 * @return t@CTCY
	 */
	public int getFileSize() {
		return Integer.parseInt(Native.get_fileSize(getPtr()));
	}

	/**
	 * t@C쐬擾.
	 * 
	 * @return t
	 */
	public String getFileCreatedDate() {
		return Native.get_fileCreatedDate(getPtr());
	}

	/**
	 * t@CύX擾.
	 * 
	 * @return t
	 */
	public String getFileModifiedDate() {
		return Native.get_fileModifiedDate(getPtr());
	}

	/**
	 * t@CXV擾.
	 * 
	 * @return t
	 */
	public String getFileUpdatedDate() {
		return Native.get_fileUpdatedDate(getPtr());
	}

	/**
	 * ZLeB[擾.
	 * 
	 * @return ZLeB[
	 */
	public String getSecurity() {
		return Native.get_security(getPtr());
	}

	/**
	 * vgR擾.
	 * 
	 * @return vgR
	 */
	public String getProtocol() {
		return Native.get_protocol(getPtr());
	}

	/**
	 * NameProp擾.
	 * 
	 * @return NameProp
	 */
	public String getNameProp() {
		return Native.get_nameProp(getPtr());
	}

	/**
	 * HTML.
	 * 
	 * @param html
	 *            HTML
	 */
	public void write(String html) {
		Native.write(getPtr(), html);
	}

	/**
	 * HTML.
	 * 
	 * @param html
	 *            HTML
	 */
	public void writeln(String html) {
		Native.writeln(getPtr(), html);
	}

	public IDispatch open(String url, Variant name, Variant features,
			Variant replace) {
		return Native.open(getPtr(), url, name, features, replace);
	}

	/**
	 * HTMLݏI.
	 */
	public void close() {
		Native.close(getPtr());
	}

	/**
	 * HTMLNA[.
	 */
	public void clear() {
		Native.clear(getPtr());
	}

	public boolean queryCommandSupported(String cmdID) {
		return Native.queryCommandSupported(getPtr(), cmdID);
	}

	public boolean queryCommandEnabled(String cmdID) {
		return Native.queryCommandEnabled(getPtr(), cmdID);
	}

	public boolean queryCommandState(String cmdID) {
		return Native.queryCommandState(getPtr(), cmdID);
	}

	public boolean queryCommandIndeterm(String cmdID) {
		return Native.queryCommandIndeterm(getPtr(), cmdID);
	}

	public String queryCommandText(String cmdID) {
		return Native.queryCommandText(getPtr(), cmdID);
	}

	public Variant queryCommandValue(String cmdID) {
		return Native.queryCommandValue(getPtr(), cmdID);
	}

	public boolean execCommand(String cmdID, boolean showUI, Variant value) {
		return Native.execCommand(getPtr(), cmdID, showUI, value);
	}

	/**
	 * HTMLvf.
	 * 
	 * @return HTMLvf
	 */
	public IHTMLElement create(String tagName) {
		return Native.createElement(getPtr(), tagName);
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #create(String)
	 */
	public IHTMLElement create(String tagName, boolean addChild) {
		return create(tagName);
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param x
	 *            X
	 * @param y
	 *            Y
	 * @return HTMLvf
	 */
	public IHTMLElement elementFromPoint(int x, int y) {
		return Native.elementFromPoint(getPtr(), x, y);
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #create(String)
	 */
	public IHTMLElement elementFromPoint(int x, int y, boolean addChild) {
		return elementFromPoint(x, y);
	}

	/**
	 * eEBhE擾.
	 * 
	 * @return HTMLEBhE
	 */
	public IHTMLWindow getParentWindow() {
		return Native.get_parentWindow(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getParentWindow()
	 */
	public IHTMLWindow getParentWindow(boolean addChild) {
		return getParentWindow();
	}

	/**
	 * x[XURLݒ.
	 * 
	 * @param url
	 *            URL
	 */
	public void setBaseUrl(String url) {
		Native.put_baseUrl(getPtr(), url);
	}

	/**
	 * x[XURL擾.
	 * 
	 * @return URL
	 */
	public String getBaseUrl() {
		return Native.get_baseUrl(getPtr());
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param id
	 *            ID
	 * @return HTMLEBhE
	 */
	public IHTMLElement getElementById(String id) {
		return Native.getElementById(getPtr(), id);
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getElementById(String)
	 */
	public IHTMLElement getElementById(String id, boolean addChild) {
		return getElementById(id);
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param name
	 *            
	 * @return RNV
	 */
	public IHTMLElementCollection getElementsByName(String name) {
		return Native.getElementsByName(getPtr(), name);
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getElementsByName(String)
	 */
	public IHTMLElementCollection getElementsByName(String name,
			boolean addChild) {
		return getElementsByName(name);
	}

	/**
	 * HTMLvf擾.
	 * <p>
	 * ̖OꍇA擪1ԂB
	 * </p>
	 * 
	 * @param name
	 *            
	 * @return HTMLvf
	 */
	public IHTMLElement getElementByName(String name) {
		IHTMLElementCollection c = Native.getElementsByName(getPtr(), name);

		// 擪̈ꌏԂ̂ŁA擾
		IHTMLElement e = c.item(name, 0);
		c.dispose();

		return e;
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getElementByName(String)
	 */
	public IHTMLElement getElementByName(String name, boolean addChild) {
		return getElementByName(name);
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param name
	 *            ^O
	 * @return RNV
	 */
	public IHTMLElementCollection getElementsByTagName(String name) {
		return Native.getElementsByTagName(getPtr(), name);
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getElementsByTagName(String)
	 */
	public IHTMLElementCollection getElementsByTagName(String name,
			boolean addChild) {
		return getElementsByTagName(name);
	}

	/**
	 * tH[JXݒ.
	 */
	public void focus() {
		Native.focus(getPtr());
	}

	/**
	 * tH[JXL擾.
	 * 
	 * @return tH[JXL
	 */
	public boolean hasFocus() {
		return Native.hasFocus(getPtr());
	}

	/**
	 * HTMLhLg쐬.
	 * 
	 * @param url
	 *            URL
	 * @param options
	 *            IvV
	 * @return HTMLhLg
	 */
	public IHTMLDocument createDocumentFromUrl(String url, String options) {
		return Native.createDocumentFromUrl(getPtr(), url, options);
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #createDocumentFromUrl(String, String)
	 */
	public IHTMLDocument createDocumentFromUrl(String url, String options,
			boolean addChild) {
		return createDocumentFromUrl(url, options);
	}

	/**
	 * WebBrowserRg[擾.
	 * 
	 * @return WebBrowserRg[
	 */
	public IWebBrowser getWebBrowser() {
		return Native.getWebBrowser(getPtr());
	}

	/**
	 * @see ComPtr#disposeChild()
	 * @deprecated
	 * @see #getWebBrowser()
	 */
	public IWebBrowser getWebBrowser(boolean addChild) {
		return getWebBrowser();
	}

	private static class Native {
		//
		// original
		//

		private static native IWebBrowser getWebBrowser(long ptr);

		//
		// IHTMLDocument
		//
		private static native IDispatch get_Script(long ptr);

		//
		// IHTMLDocument2
		//

		private static native IHTMLElementCollection get_all(long ptr);

		private static native IHTMLElement get_body(long ptr);

		private static native IHTMLElement get_activeElement(long ptr);

		private static native IHTMLElementCollection get_images(long ptr);

		private static native IHTMLElementCollection get_links(long ptr);

		private static native IHTMLElementCollection get_forms(long ptr);

		private static native IHTMLElementCollection get_anchors(long ptr);

		private static native void put_title(long ptr, String title);

		private static native String get_title(long ptr);

		private static native String get_readyState(long ptr);

		private static native IHTMLFramesCollection get_frames(long ptr);

		private static native void put_alinkColor(long ptr, Variant p);

		private static native Variant get_alinkColor(long ptr);

		private static native void put_bgColor(long ptr, Variant p);

		private static native Variant get_bgColor(long ptr);

		private static native void put_fgColor(long ptr, Variant p);

		private static native Variant get_fgColor(long ptr);

		private static native void put_linkColor(long ptr, Variant p);

		private static native Variant get_linkColor(long ptr);

		private static native void put_vlinkColor(long ptr, Variant p);

		private static native Variant get_vlinkColor(long ptr);

		private static native String get_referrer(long ptr);

		private static native IHTMLLocation get_location(long ptr);

		private static native String get_lastModified(long ptr);

		private static native void put_url(long ptr, String url);

		private static native String get_url(long ptr);

		private static native void put_domain(long ptr, String domain);

		private static native String get_domain(long ptr);

		private static native void put_cookie(long ptr, String cookie);

		private static native String get_cookie(long ptr);

		private static native void put_charset(long ptr, String charset);

		private static native String get_charset(long ptr);

		private static native void put_defaultCharset(long ptr, String charset);

		private static native String get_defaultCharset(long ptr);

		private static native String get_mimeType(long ptr);

		private static native String get_fileSize(long ptr);

		private static native String get_fileCreatedDate(long ptr);

		private static native String get_fileModifiedDate(long ptr);

		private static native String get_fileUpdatedDate(long ptr);

		private static native String get_security(long ptr);

		private static native String get_protocol(long ptr);

		private static native String get_nameProp(long ptr);

		private static native void write(long ptr, String html);

		private static native void writeln(long ptr, String html);

		private static native IDispatch open(long ptr, String url,
				Variant name, Variant features, Variant replace);

		private static native void close(long ptr);

		private static native void clear(long ptr);

		private static native boolean queryCommandSupported(long ptr,
				String cmdID);

		private static native boolean queryCommandEnabled(long ptr, String cmdID);

		private static native boolean queryCommandState(long ptr, String cmdID);

		private static native boolean queryCommandIndeterm(long ptr,
				String cmdID);

		private static native String queryCommandText(long ptr, String cmdID);

		private static native Variant queryCommandValue(long ptr, String cmdID);

		private static native boolean execCommand(long ptr, String cmdID,
				boolean showUI, Variant value);

		private static native IHTMLElement createElement(long ptr, String tag);

		private static native IHTMLElement elementFromPoint(long ptr, int x,
				int y);

		private static native IHTMLWindow get_parentWindow(long ptr);

		//
		// IHTMLDocument3
		//

		private static native void put_baseUrl(long ptr, String url);

		private static native String get_baseUrl(long ptr);

		private static native IHTMLElementCollection getElementsByName(
				long ptr, String name);

		private static native IHTMLElement getElementById(long ptr, String id);

		private static native IHTMLElementCollection getElementsByTagName(
				long ptr, String name);

		//
		// IHTMLDocument4
		//

		private static native void focus(long ptr);

		private static native boolean hasFocus(long ptr);

		private static native IHTMLDocument createDocumentFromUrl(long ptr,
				String url, String options);
	}
}